;23.04.2020 Version Z9001 V.Pohlers
;Z9001 Anpassung Systemanbindung, Save/Load
;autom. Einrichtung Save-Bereich vor EOR
;Anpassung IN-SAVE Bereichsgrenzentest
;neues Kdo '-' WANDLUNG NL->CR


	cpu	Z80

	;PN	TXED
;******************************
;*                            *
;*      MICROWORD  1.5/18U    *
;*                            *
;*     IG-HC TU-DRESDEN       *
;*                            *
;*         11.09.88           *
;*                            *
;*   (c) by Rainer Brosig     *
;*                            *
;******************************
;
;KONSTANTEN
;
LIPUF:	EQU	20H		;INP-PUFFERLAENGE
SLINE:	EQU	0		;)LIST-SPALTENPOSITIONEN
SPOS:	EQU	4		;)
SFREE:	EQU	9		;)
STXP:	EQU	15		;)
SETP:	EQU	20		;)
SRR:	EQU	23		;)
SINSA:	EQU	28		;POS. INS-ANZEIGE
SINPL:	EQU	0		;)
;STACK:	EQU	0300H		;STACK-Bereich
CUZEI:	EQU	0A0H		;CODE CURSOR-ZEICHEN FIND
BWSE:	EQU	0EFBFH
NL:	EQU	1EH		;NEW-LINE
CR:	EQU	0DH		;CAR. RET.
LF:	EQU	0AH		;LINE-FEED
TAB:	EQU	09H		;TABULATORZEICHEN
;SYSCU:	EQU	2BH		;SYSTEM-CURSORZELLE
VW:	EQU	7		;ANZ.ZEICHEN VOR ZE RANDW.
;
	ORG	300H
;
ANF:	JP	SPTST		;PROGR.-START
	db	"WORD    ",0
	db	0
;
INCHR:	jp 	0F009h		;<A> <- TASTATUR
;
INKEY:	call	0F006h		;<A> <- TASTENPOLLING
	LD	HL,(TAPUF)
	LD	(HL),0
	ret
;
DRAKK:	JP	ZDR1		;<A> -> DRUCKER
;
DRDEL:	ret			;SETZT EXTERNEN LOG. DR.-TR.ZUR.
;
BEEP:	jp	0F8AEh		;BEEP AUSGABE
;
SYS:	jp	0		;SYSTEMRUECKKEHR
;
MC1:	DB	0C7H		;OFFENER CURS.
MC3:	DB	0FFH		;VERDECKTER CURSOR
CU7B:	DB	0h		;CU.GRFKZ=0/BIT7=80H
;
ETX:	DB	3		;ENDE TEXT ZEICH.
STX:	DB	2		;START TEXT ZEICH.
;
CODTB:	DB	9		;CU-RECHTS
	DB	8		;CU-LINKS
	DB	0AH		;CU-RUNTER
	DB	0BH		;CU-HOCH
	DB	1		;SEITE VORWAERTS		ctrl-a
	DB	5		;SEITE RETOUR			ctrl-e
	DB	13H		;LOESCHE ZEICHEN LINKS		ctrl-s,pause	z9001
	DB	1FH		;LOESCHE ZEICHEN RECHTS		del		z9001
	DB	3		;UMSCHALTUNG BILD/KOMM.		stop
	DB	1BH		;ESC ANKUENDIGUNG STEUERZ.	esc
	DB	12H		;WANDLUNG BUCHST.		ctrl-r
	DB	15H		;UMSCHALTUNG CAPS		ctrl-u
	DB	0FH		;LOESCHEN ZEILE			ctrl-o
	DB	11H		;ERSETZEN WIEDRHOLEN		ctrl-q
	DB	0CH		;FF				ctrl-l
	DB	0DH		;ENTER				enter
	DB	14H		;TAB-DUMMY			ctrl-t
	DB	06H		;TAB-DUMMY			ctrl-f
	DB	0EH		;NUL-DUMMY			ctrl-n
	DB	1AH		;EINFUEGEN/UEBERSCHR.		ins		z9001
	DB	16H		;SETZEN MARKE			ctrl-v
	DB	18H		;WORT RECHTS			tab -->|
	DB	19H		;WORT LINKS			tab |<--
	DB	1CH		;RECLAIM			list
CODTE:	DB	0		;RESERVE
;
;INTERNER CODE
;
ICOTB:	DB	1		;CUR
	DB	2		;CUL
	DB	4		;CUU
	DB	5		;CUO
	DB	6		;SEITE VORW.
	DB	7		;SEITE ZURUECK
	DB	8		;DEL LINKS
	DB	9		;DEL RECHTS
	DB	10		;UMSCH.BILD/KOMMANDO
	DB	1BH		;ANKUEND.ST.-KODE
	DB	11		;WANDL.GROSS/KLEIN
	DB	15		;CAPS
	DB	16		;DEL LINE
	DB	14		;ERSETZEN/WIEDERHOLEN
	DB	12		;FORM-FEED
	DB	CR		;ENTER
	DB	17		;TAB
	DB	17		;TAB
	DB	0		;NUL
	DB	13H		;INS/OVERWR.
	DB	16H		;SETZEN MARKE
	DB	18H		;WORT RECHTS
	DB	19H		;WORT LINKS
	DB	1CH		;RECLAIM
	DB	0		;RESERVE
;
;TEXTPUFFER-DATEN
;
TPANF:	DW	firstp		;TEXTPUFFERANFANG (STX)
TPEND:	DW	0BFFFH		;MAX.TEXTENDE+PUFFER
;
;BILDSCHIRM
;
BSANF:	DW	0EC00H		;BWS-ANFANG
BSSPA:	DW	40		;BS-SPALTEN
BSZEI:	DW	24		;BS-ZEILEN
TAPUF:	DW	0025h		;TASTATURPUFFER	; nur fr drucker Abfrage <STOP>
ANFTX:	DW	firstp		;ABSOLUTE UNTERE TEXTGRENZE
OFFS:	DB	0A0H		;OFFSET ZUR STZ.AUSGABE
AUTOR:	DB	"(c) by R. Brosig V 1.518U 11.09.88"," VPohlers ",DATE

SAVEG:	equ	400H		;MIN. SAVEGR.
SAVEB:	DW	0	 	;savebereich beginn
SAVBE:	DW	0		;savebereich ende

;
;PROGRAMMANFANG
;1.SPEICHERTEST
;
SPTST:	LD	(PUFSP),SP
;;	LD	SP,STACK

	;farbe
	ld	a,(0027h)	; ATTRIB aktuelle Farbe
	ld	hl,0E800h
	ld	de,0E801h
	ld	bc,960-1
	ld	(hl),a
	ldir
	;
	CALL	CLS
	LD	HL,0
	LD	(MLSA),HL		;SAVE-LAENGE=0
	LD	HL,(BSANF)
	LD	(HL),'M'
	LD	HL,(ANFTX)
	ld	hl,(0036h)	; EOR
SPTS1:	LD	(SPEND),HL
	ld	(SAVBE),hl
	ld	bc,-SAVEG
	add	hl,bc
	LD	(TPEND),HL
	inc	hl
	ld	(SAVEB),hl
;ggf. Warmstart	
	LD	HL,(TPANF)
	LD	A,(HL)
	CP	A, NL
	JP	Z, WST		;WARMSTART
;		
ANF1:	CALL	CLS
	LD	HL,(BSANF)		;DB BS-ANF.
	LD	DE,(BSSPA)		;DB BS SPALTEN
	LD	A,(BSZEI)		;DB BS-ZEILENZAHL
	LD	(MBWSA),HL		;MERKE BWS-ANFANG
	DEC	A
	DEC	A
	LD	B,A
	LD	A,(MODE)		;EXTENDET MODE?
	OR	A
	LD	A,B
	JR	NZ, ANF2
	DEC	A
ANF2:	LD	(MBWZZ),A		;MERKE BWS-ZEILENZAHL
	LD	(AKTCZ),A
	LD	A,E		;SPALTENZAHL
	LD	(MBWZL),A
;
;BERECHNEN BILDPOSITIONEN
;
	LD	HL,SINPL		;SPALTE INP.LINES
	LD	A,(MBWZZ)
	LD	B,A
BBPS1:	ADD	HL,DE
	DJNZ	BBPS1
	LD	(PINPL),HL
	LD	HL,SLINE		;SP.POS LINE
	LD	A,(MBWZZ)
	INC	A
	LD	B,A
	LD	A,(MODE)
	OR	A
	LD	A,B
	JR	NZ, BBPS2
	INC	A
	LD	B,A
BBPS2:	ADD	HL,DE
	DJNZ	BBPS2
	LD	(PLINE),HL
	LD	HL,SPOS
	LD	B,A
BBPS5:	ADD	HL,DE
	DJNZ	BBPS5
	LD	(PPOS),HL
	LD	HL,SFREE		;POS. FREE
	LD	B,A
BBPS3:	ADD	HL,DE
	DJNZ	BBPS3
	LD	(PFREE),HL
	LD	HL,SRR		;SP.-POS.RECHTER RAND
	LD	B,A
BBPS4:	ADD	HL,DE
	DJNZ	BBPS4
	LD	(PRR),HL
	LD	HL,STXP
	LD	B,A
MPETX:	ADD	HL,DE
	DJNZ	MPETX
	LD	(PETX),HL
	LD	HL,SETP
	LD	B,A
MPETP:	ADD	HL,DE
	DJNZ	MPETP
	LD	(PETP),HL
	LD	HL,SINSA
	LD	B,A
MPINA:	ADD	HL,DE
	DJNZ	MPINA
	LD	(PINSA),HL
;
;INIT TEXTPUFFERZEIGER
;
	LD	HL,(BSANF)
	LD	(HL),'I'
	LD	HL,(TPANF)
	INC	HL
	LD	(SOF),HL
	LD	(MARK1),HL
	DEC	HL
	EX	DE,HL
	LD	HL,(TPEND)
	LD	A,(MBWZZ)
	LD	C,A
	XOR	A
	LD	B,A
	SBC	HL,BC
	LD	(CPOM1),HL
	DEC	HL
	LD	(LETZT),HL
	SBC	HL,DE
	INC	A
	LD	(ASP),A
;
;SUCHEN TEXTENDE
;
SUTXE:	INC	DE
	DEC	HL
	LD	A,L
	OR	H
	JR	Z, SUTX1		;TEXTLAENGE 0
	LD	A,(ETX)
	LD	C,A
	LD	A,(DE)
	CP	A, C
	JR	Z, SUTX1
	CP	A, 0FFH
	JR	NZ, SUTXE
SUTX1:	LD	A,(ETX)
	LD	(DE),A
	DEC	DE
SUTX2:	LD	(CUPOM),DE		;CURSOR-POS.IM SPEICHER
	CALL	WCRNL		;WANDLUNG CRLF->NL
	JP	STED
;
BYE:	CALL	BYE1
	LD	SP,(PUFSP)
	JP	SYS
;
BYE1:	CALL	CUATE		;CURSOR ANS TEXTENDE
	CALL	CLS1
	LD	HL,(TPANF)
	LD	A,(STX)
	LD	(HL),A
	LD	HL,(CUPOM)
	LD	A,(ETX)
	INC	HL
	LD	(HL),A
	LD	A,(MODE)
	OR	A
	JP	NZ, COMPR
	RET
;
;DE-ANZEIGEN HEX AUF HL-POSITION
;
OUTDE:	LD	A,D
	CALL	OUTA
	LD	A,E
;
;AKKU-ANZEIGEN HEX AUF HL POSITION
;
OUTA:	PUSH	AF
	RR	A
	RR	A
	RR	A
	RR	A
	CALL	OUTA1
	POP	AF
OUTA1:	PUSH	AF
	AND	A, 0FH
	ADD	A, 30H
	CP	A, 3AH
	JR	C, OUTA2
	ADD	A, 07H
OUTA2:	CALL	WRPOS
	POP	AF
	INC	HL
	RET
;
;TASTATUREING. MIT UMK.
;
COTAS:	PUSH	BC
	PUSH	HL
	LD	HL,MZT
	XOR	A
	OR	(HL)
	LD	(HL),0
	JR	NZ, COTA3
	CALL	INCHR
COTA3:	LD	HL,CODTE
	LD	BC,CODTE-CODTB+1
	CPDR
	JR	Z, COTA1
	JR	COTA2
;
;UMKODIEREN
;
COTA1:	LD	HL,ICOTB
	ADD	HL,BC
	LD	A,(HL)
COTA2:	POP	HL
	POP	BC
	RET
;
;BILDSCHIRMLOESCHEN
;
CLS:	;LD	A,0CH
	;CALL	OUTCH
	ld	a,' '
	ld	hl,0EC00h
	ld	de,0EC01h
	ld	bc,960-1
	ld	(hl),a
	ldir
	LD	HL,(MBWSA)
	LD	(EPOS),HL
;
;CURSOR BILDANF.
;
HOME:	PUSH	HL
	LD	HL,(MBWSA)		;MERKE BWS ANF.
	LD	(CUPOB),HL		;CU-POS. BILD
	POP	HL
	RET
;
;SCHREIBEN AKKU AUF CU-POS. IM BWS UND CUPOB+1
; ERHOEHEN POINTER
;
WRZEI:	PUSH	HL
	LD	HL,(CUPOB)
	CALL	WRPOS
	INC	HL
	LD	(CUPOB),HL
	POP	HL
	RET
;
;SCHREIBEN AKKU AUF CURORPOSITION
;
WRPOS:	
	push	de
	push	hl
	ld	de,BWSE
	sbc	hl,de		;cupos>=bwse?
	pop	hl
	pop	de
	ret	nc

	CP	A, ' '
	JR	NC, NSTZ
	PUSH	HL
	LD	HL,OFFS
	ADD	A, (HL)		;STZ.DARSTELUNG
	POP	HL
NSTZ:	LD	(HL),A
	RET
;
;SCHREIBEN AUF CURSORPOS.MIT WEITERRUECKEN
; EINGABE-CURSOR
;
WRPOC:	LD	(HL),A
	CP	A, CUZEI
	RET	NZ
WRPO1:	LD	HL,(EPOS)
	LD	(HL),CUZEI
	INC	HL
	LD	(EPOS),HL
	DEC	HL
	RET
;
;RUECKLESEN ZEICHEN AUF CU-POS. (HL)
;
;
RDPOS:	LD	A,(HL)
	CP	A, CUZEI
	JR	NZ, RDPO1
	LD	A,' '
RDPO1:	RET
;
;NEUSTART EDITOR-BILDMODE
;
STED:	XOR	A
	LD	(FHTYP),A
	CALL	SETNL		;SETZEN NL AM TEXTENDE UND ANF.
	CALL	UKBM		;UMSCHALTEN IN BILDMODE
	JP	RETED
;
;ENDE EDITIERSCHLEIFE
;
EDZYK:	XOR	A
	LD	(FHTYP),A
	LD	BC,(MARK1)
	LD	HL,(CUPOM)
	INC	HL
	CALL	DHLBC		;DIFFERENZ BC=HL-BC+1
	JR	NC, EDZY1		;>0
	CALL	SETML		;MARKE AUF LETZTE ZELLE
;
;*****************************************************
;BEGINN EDITIERSCHLEIFE
;
;BESTIMMEN DER SPALTENPOSITION
;
;
EDZY1:	CALL	TLUT	;BC=TEXTLAENGE UNTERER TEIL
	LD	A,NL		;NL
	LD	HL,(CUPOM)		;SUCHEN AB CURSORPOS.
	CPDR		;SUCHEN LETZTES NL
	EX	DE,HL		;DE=ADR.NL-1
;
;TAB-INTERPRETER
;
SETS7:	LD	A,(DE)
	CP	A, TAB
	JR	Z, SETS2
	CP	A, NL		;POS AM ZEILENANF.=1
	JR	Z, SETS0
SETS8:	OR	A
	LD	HL,(CUPOM)
	SBC	HL,DE
	JR	Z, SETS6		;ENDE DER INTERPRETATION
	INC	B		;POS.+1
	INC	DE		;POINTER+1
	JR	SETS7
SETS0:	LD	B,1		;1.POS.
	JR	SETS8
SETS2:	LD	A,7		;ACHTER TAB
	AND	A, B		;ANZ. UEBER TAB
	JR	Z, SETS9		;ACHTERPOS.
	LD	A,B
	AND	A, 0F8H		;SETZEN AUF VOLLEN ACHTER
	ADD	A, 8		; AUF NAECHSTEN TAB
	LD	B,A
SETS9:	INC	B		;CURSOR STEHT HINTER TAB
	JR	SETS8
SETS6:	LD	A,B
	LD	(ASP),A		;AKTUELLE SPALTE
;
;RANDWARNUNG+WORTUMBRUCH
;
SETS1:	LD	A,(RRA)
	SUB	VW		;N ZEICHEN VOR Z.ENDE BEEP
	JR	C, SETS3		;RW+WU AUS
	CP	A, B
	PUSH	BC
	LD	BC,4039H
	CALL	C, BEEP
	POP	BC
	LD	A,(RRA)
	INC	A
	CP	A, B
	JR	NZ, SETS3
	LD	HL,(CUPOM)
SETS5:	LD	A,(HL)
	CP	A, ' '
	JR	Z, SETS4
	CP	A, TAB
	JR	Z, SETS4
	CP	A, NL
	JR	Z, SETS3
	DEC	HL
	JR	SETS5
;WANDELN NL AM WORTENDE IN SPACE
SETS4:	LD	A,NL
	LD	(HL),A
	LD	HL,(CPOM1)		;(B)>VW
	CPIR
	EX	DE,HL		;DE EIN ZEICHEN HINTER GEF.NL
	LD	HL,(LETZT)		;1. NL F. TEXTENDE
	SBC	HL,DE
	JR	C, SETS3
	EX	DE,HL
	DEC	HL
	LD	(HL),' '
;
SETS3:	CALL	BILD
	CALL	STCOM
	CALL	COTAS		;TASTATURABFRAGE MIT KONVERT.
	CALL	GOKOM		;SPRUNG ZUM STZ.UP
;
;STEUERTASTENVERTEILER
;
	DB	21		;21 FUNKT.-TASTEN
	DW	NOSTZ		;BEHANDLUNG,WENN KEIN STZ
	DB	0CH		;FF
	DW	FF
	DB	17		;TAB
	DW	TABA
	DB	14		;ERS./WIED.
	DW	ERWI
	DB	1		;CUR
	DW	CUR
	DB	2		;CUL
	DW	CUL
	DB	4		;CUU
	DW	CUU
	DB	5		;CUO
	DW	CUO
	DB	6		;SEITE VORW.
	DW	SVOR
	DB	7		;S. ZURUECK
	DW	SRET
	DB	CR		;ENTER
	DW	NL0
	DB	8		;DEL-Z.LINKS
	DW	DELZL
	DB	9		;DEL
	DW	DELZ
	DB	16		;DEL-LINE
	DW	DELLN
	DB	11		;WANDL. BUCHST.
	DW	WGK
	DB	15		;CAPS
	DW	CAPS
	DB	10		;UMSCH.BILD/KOMMANDO
	DW	UKBM
	DB	13H		;INS/OVERWR.
	DW	IOVR
	DB	16H		;SETZEN MARKE
	DW	SETM
	DB	18H		;WORT RECHTS
	DW	CWR
	DB	19H		;WORT LINKS
	DW	CWL
	DB	1CH		;RECLAIM
	DW	RECL
;
;FORTSETZUNG NACH AUSF.DES EDIT-K.
;
RETED:	LD	(EDTYP),A
	LD	A,(FHTYP)		;FEHLERNUMMER
	OR	A
	JP	Z, EDZYK		;FEHLERFREI ABGEARB.
;
;AUSWERTUNG FEHLERTYP
;
	XOR	A
	LD	(EDTYP),A
	CALL	CLS1
	EXX
	LD	BC,4039H		;BEEP TONPARAM.
	CALL	BEEP
	EXX
	CALL	OUTSTR
	DB	NL
	DB	"ERROR:",82H
	DB	0
	LD	A,(FHTYP)
	CP	A, 1
	JR	NZ, FEL2
	CALL	OUTSTR
	DB	"memory end!"
	DB	0
	JR	FELE
;
FEL2:	CP	A, 2
	JR	NZ, FELE
	CALL	OUTSTR
	DB	"undefined operation!"
	DB	0
FELE:	CALL	OUTSTR
	DB	NL,NL,NL
	DB	9AH
	DB	">ENT<"
	DB	0
	CALL	COTAS
	JP	EDZYK
;
;KOMMANDO-ADRESS-VERTEILER
;
GOKOM:	POP	HL
	LD	B,(HL)		;TABELLENLAENGE
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE=ADR.WENN NICHT GEFUNDEN
	INC	HL
GOKO1:	CP	A, (HL)
	INC	HL
	JR	NZ, GOKO2
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	JR	GOKO3
;
GOKO2:	INC	HL
GOKO3:	INC	HL
	DJNZ	GOKO1
	EX	DE,HL
	PUSH	DE
	JP	(HL)		;CODEBEHANDLUNG,RUECKK.M.RET
;
;NEUE ZEILE BEGINNEN
;
NL0:	LD	A,NL
	CALL	WRZIT		;ZEICH.AN UNTER.TEIL ANFUEG.
	JR	C, NL1		;FEHLER SPEICHERENDE
	CALL	AZINC		;AKT. ZEILE INCREM.
	CALL	SET1S		;SETZEN CURS.AUF ZEILENANF.
NL1:	LD	A,12H
	RET
;
;FORMFEED
;
FF:	LD	B,1
	LD	A,0CH
	JR	BMALA
;
;RECLAIM
;
RECL:	CALL	KFREE
	LD	A,1FH
	RET	C
	LD	HL,(CPOM1)
	DEC	HL
	LD	(CPOM1),HL
	LD	A,18H
	RET
;
;TAB AUSFUEHREN
;
TABA:	LD	B,8		;ANZAHL
	LD	A,TAB
	JR	BMALA
;
NOSTZ:	OR	A		;NUL
	JR	Z, NSTZ2
	CP	A, 1BH		;ANKUEND.ST-ZEICH.
	JR	NZ, KANK		;KEINE ANKUENDIGUNG
	CALL	INCHR
	JR	NSTZ2
;
KANK:	CP	A, ' '
	JR	NC, NSTZ2
NSTZ1:	LD	A,2
	LD	(FHTYP),A
	JR	BMEND
;
NSTZ2:	LD	HL,MCAPS
	CALL	CAPSA
	LD	B,1
;
;B-MAL AUSGEBEN VON (A)
;
BMALA:	PUSH	BC
	CALL	WRZIT		;ZEICHEN AN UNTEREN TEXT ANFUEG.
	CP	A, '-'
	JR	NZ, BMAL2
	LD	A,(ASP)
	LD	B,A
	LD	A,(RRA)
	SUB	VW		;N ZEICH V. Z.-ENDE
	CP	A, B
	JR	NC, BMAL2
	INC	HL
	LD	(HL),NL
	LD	(CUPOM),HL
BMAL2:	POP	BC
BMAL1:	CALL	ASINC		;SPALTE INC.
	DJNZ	BMAL1
BMEND:	LD	A,NL
	RET
;
;CURSOR NACH OBEN
;
CUO:	LD	E,1
	CALL	STXTP		;HL=TEXTPOINTER SETZEN
	JR	NC, CUO1
	JR	NZ, CUO2
	LD	E,2
	CALL	STXTP		;TEXTPOINTER HL SETZEN
	CALL	AZDEC		;ZEILE ZURUEK
CUO1:	CALL	SET1S		;SETZEN AUF ERSTE SPALTE
	CALL	TXTNO		;TEXTTEIL NACH OBEN
	LD	HL,(ALINE)
	DEC	HL
	LD	(ALINE),HL
CUO2:	LD	A,1CH
	RET
;
;CURSOR NACH UNTEN
;
CUU:	LD	E,1
	CALL	STPO
	DEC	HL
	JR	C, CUU1
	CALL	AZINC		;ZEILE INC.
	CALL	SET1S		;1.SP
	JR	CUU2
CUU1:	JR	NZ, CUU3
	LD	HL,(LETZT)
	CALL	SETLS		;SETZEN AUF LETZTE SP.
	LD	A,(HL)
	CP	A, NL
	JR	NZ, CUU2
	CALL	AZINC		;ZEILE INC.
CUU2:	CALL	TXTNU		;TEXTT.N.UNTEN
	LD	HL,(ALINE)
	INC	HL
	LD	(ALINE),HL
CUU3:	LD	A,16H
	RET
;
;CURSOR LINKS
;
CUL:	CALL	KFREE		;KONTR.FREE-RAM
	JR	C, CUL2
	CALL	TLUT		;TEXTLAENGE UNTERE TEIL (BC)
	JR	C, CUL2
	LD	HL,(CUPOM)
	LD	A,(HL)
	DEC	HL
	LD	(CUPOM),HL
	LD	HL,(CPOM1)
	DEC	HL
	LD	(HL),A
	LD	(CPOM1),HL
	CP	A, NL
	JR	NZ, CUL1
	CALL	SETLS		;SET LTZTE SP.
	CALL	AZDEC		;ZEILE ZURUECK
	JR	CUL2
CUL1:	CALL	BAK1S		;EINE SPALTE ZUR.
	OR	A		;CY=0
CUL2:	LD	A,1CH
	RET
;
;CURSOR RECHTS
;
CUR:	CALL	KFREE		;KONTR.-FREE-RAM
	JR	C, CUR3
	CALL	LAEOT		;LAENGE OBERER TEIL
	JR	C, CUR3
	LD	HL,(CPOM1)
	LD	A,(HL)
	INC	HL
	LD	(CPOM1),HL
	LD	HL,(CUPOM)
	INC	HL
	LD	(HL),A
	LD	(CUPOM),HL
	CP	A, NL
	JR	NZ, CUR1
	CALL	AZINC		;ZEILE INC.
	CALL	SET1S		;1.SP.
	JR	CUR4
CUR1:	CP	A, TAB
	LD	B,1
	JR	NZ, CUR2
	LD	B,8
CUR2:	CALL	ASINC		;SP.INC
	DJNZ	CUR2
CUR4:	OR	A		;CY=0
CUR3:	LD	A,16H
	RET
;
;WORT RECHTS
;
CWR:	LD	HL,(CPOM1)
	CALL	TTRZ		;TRENNZEICHEN?
	JR	NZ, CWR1		;STEHT IM WORT
CWR2:	CALL	CUR		;VOR BIS WORTANF.
	RET	C	;ENDE TEXT
	LD	HL,(CPOM1)
	CALL	TTRZ
	JR	Z, CWR2
	XOR	A		;VOLLES BILD
	RET
CWR1:	CALL	CUR
	RET	C
	LD	HL,(CPOM1)
	CALL	TTRZ
	JR	Z, CWR2
	JR	CWR1		;NOCH NICHT WORTENDE
;
;WORT LINKS
;
CWL:	LD	HL,(CUPOM)
	CALL	TTRZ		;TRENNZEICHEN?
	JR	NZ, CWL1
CWL2:	CALL	CUL
	RET	C
	LD	HL,(CUPOM)
	CALL	TTRZ
	JR	Z, CWL2
CWL1:	CALL	CUL
	RET	C
	LD	HL,(CUPOM)
	CALL	TTRZ
	JR	NZ, CWL1		;NOCH KEIN TRENNZEICHEN
	LD	A,18H		;ED-TYP
	RET
;
;UP-TEST TRENNZEICHEN
;
TTRZ:	LD	A,(HL)
	CP	A, ' '
	RET	Z
	CP	A, TAB
	RET	Z
	CP	A, NL
	RET	Z
	CP	','
	RET
;
;SEITE VOR
;
SVOR:	LD	A,(MBWZZ)
	INC	A
	LD	HL,AKTCZ
	SUB	(HL)
	SUB	2
	JR	C, SVOR1
	JR	Z, SVOR1
	LD	E,A
	CALL	STPO
	DEC	HL
	LD	A,1FH
	RET	C
	RET	NZ
	CALL	TXTNU		;TEXTT.N.UNTEN
SVOR1:	CALL	SET1Z		;1.ZEILE
	CALL	SET1S		;1.SP.
	XOR	A
	RET
;
;SEITE ZURUECK
;
SRET:	LD	A,(AKTCZ)
	LD	HL,MBWZZ
	ADD	A, (HL)
	SUB	2
	LD	E,A
	CALL	STXTP		;TEXTPOINTER HL SETZEN
	JP	C, CUATA
	JP	NZ, CUATA
	CALL	TXTNO		;TEXTTEIL NACH OBEN
	CALL	SET1Z		;1.Z.
	CALL	SET1S		;1.SP.
	XOR	A
	RET
;
;LOESCHEN ZEICHEN UNTER CURSOR
;
DELZ:	CALL	LAEOT
	JR	C, DELZ1
	LD	HL,(CPOM1)
	INC	HL
	LD	(CPOM1),HL
DELZ1:	LD	A,1AH
	RET
;
;LOESCHEN ZEICHEN LINKS VOM CURSOR
;
DELZL:	CALL	TLUT		;TEXTL.IN BC
	JR	C, DELL2
	LD	HL,(CUPOM)
	LD	A,(HL)
	DEC	HL
	LD	(CUPOM),HL
	CP	A, NL
	JR	NZ, DELL1
	CALL	SETLS		;SET LTZTE SP.
	CALL	AZDEC		;ZEILE ZURUECK
	LD	A,0
	RET
;
DELL1:	CALL	BAK1S		;EINE SPALTE ZUR.
DELL2:	LD	A,1CH
	RET
;
;LOESCHEN ZEILE
;
DELLN:	LD	E,1
	CALL	STPO
	JR	NC, DELN1
	JR	NZ, DELN3
	LD	HL,(LETZT)
	LD	A,(HL)
	CP	A, NL
	INC	HL
	JR	NZ, DELN2
DELN1:	DEC	HL
	PUSH	HL
	LD	HL,(CUPOM)
	LD	A,(HL)
	POP	HL
	CP	A, NL
	JR	NZ, DELN2
	INC	HL
DELN2:	LD	(CPOM1),HL
DELN3:	LD	A,1AH
	RET
;
WGK:	LD	HL,(CPOM1)
	LD	A,(HL)
	CALL	WGKA
	LD	(HL),A
	JP	CUR
;
;SETZEN/RUECKSETZEN CAPS-KENNZ.
;
CAPS:	LD	A,(MCAPS)
	XOR	1
	LD	(MCAPS),A
	LD	A,1FH
	RET
;
;SETZEN/RUECKSETZEN INSERT/OVERWRITE
;
IOVR:	LD	HL,MINS
	LD	A,(HL)
	XOR	1
	LD	(HL),A
IMDA:	LD	HL,MINS
	LD	A,(HL)
	BIT	0,A
	LD	A,'I'
	JR	Z, SETKZ		;INSER-KZ-SETZEN
	LD	A,'O'
SETKZ:	LD	HL,(PINSA)
	LD	BC,(BSANF)
	ADD	HL,BC
	LD	(HL),A
	LD	A,1FH		;ED-TYP
	RET
;
;SETZEN DER BS-NL's AM TEXTENDE UND TEXTANF
;
SETNL:	LD	HL,(SOF)
	DEC	HL
	LD	(HL),NL
	LD	HL,(LETZT)
	LD	A,(MBWZZ)
	LD	B,A
SENL:	INC	HL
	LD	(HL),NL
	DJNZ	SENL
	RET
;
;SETZE MARKE AUF TEXTENDE
;
SETML:	LD	HL,(LETZT)
	INC	HL
	LD	(MARK1),HL
	RET
;
;BC=TEXTLAENGE UNTERER TEIL
;HL=POINTER TOP UNTRER TEXT
;
TLUT:	LD	HL,(SOF)
;
;TEXTLAENGE AB HL BIS CUPOM
;
TLAHL:	LD	B,H
	LD	C,L
	LD	HL,(CUPOM)
	JP	DHLBC
;
;BESTIMMEN LAENGE (BC) OBERER TEXTTEIL
;CY=1 WENN OBERER TEXTPUFFER LEER
;
LAEOT:	LD	HL,(LETZT)
LAEO1:	LD	BC,(CPOM1)
	JP	DHLBC
;
;BC=FREIER RAM ZW. DEN TEILEN
;
FREER:	LD	BC,(CUPOM)
	LD	HL,(CPOM1)
	DEC	HL
	DEC	HL
;
;BC=HL-BC+1
;
DHLBC:	PUSH	HL
	AND	A, A
	SBC	HL,BC
	INC	HL
	LD	B,H
	LD	C,L
	POP	HL
	RET
;
;TRANSPORT TEXTTEIL VON UNTEREM ZUM OBEREN PUFFER
;AADR. TEXTTEIL IN HL
;
TXTNO:	CALL	TLAHL		;TEXTLAENGE BC=HL-CUPOM
	RET	C
	LD	DE,(CPOM1)
	DEC	DE
	LD	HL,(CUPOM)
	LDDR
	LD	(CUPOM),HL
	INC	DE
	LD	(CPOM1),DE
	RET
;
;TRANSPORT TEXTTEIL VON OBEREN ZUM UNTEREN PUFFER
;
TXTNU:	CALL	LAEO1
	RET	C
	LD	DE,(CUPOM)
	INC	DE
	LD	HL,(CPOM1)
	LDIR
	LD	(CPOM1),HL
	DEC	DE
	LD	(CUPOM),DE
	RET
;
SUCHD:	CPDR		;SUCHEN ZEICHEN AKKU ABWAERTS
	SCF
	RET	PE	;WENN  GEFUNDEN
	CCF
	RET
;
SUCHI:	CPIR		;SUCHEN ZEICHEN AKKU AUFWAERTS
	SCF
	RET	PE	;WENN  GEFUNDEN
	CCF
	RET
;
;SETZEN HL E-ZEILEN ZURUECK AUF ZEILENANF.IM TEXT
;IM SUCHBEREICH GANZER UNTERE TEIL
;
STXTP:	CALL	TLUT		;BC=TEXTLAENGE UNTERER TEIL
	JR	NC, STXT1		;STEHT NICHT AM TEXTANF.F
	XOR	A
	SUB	1		;Z=0 CY=1
	RET
;
STXT1:	LD	HL,(CUPOM)
	LD	A,(HL)
	CP	A, NL
	JR	NZ, STXT2		;STEHT NICHT AUF NL
	LD	A,1
	CP	A, E
	JR	NZ, STXT2		;NICHT NUR EINE ZEILE
	SCF
	RET
;
STXT2:	LD	A,NL
STXT3:	CALL	SUCHD		;SUCHEN ZEILENANF.
	JR	NC, STXT4
	DEC	E
	JR	NZ, STXT3
	INC	HL
	INC	HL
	XOR	A
	RET
;
STXT4:	INC	HL
	SCF
	CCF
	JR	Z, STXT5
	DEC	E
	RET
;
STXT5:	INC	HL
	DEC	E
	RET	Z
	DEC	HL
	DEC	E
	RET
;
;SUCHEN TEXTPOINTER HL E ZEILEN NACH OBEN
;
STPO:	CALL	LAEOT
	JR	NC, STPO1
	XOR	A
	SUB	1
	RET
;
STPO1:	LD	D,E
	LD	A,NL
	LD	HL,(CPOM1)
STPO2:	CALL	SUCHI
	JR	NC, STPO3
	DEC	E
	JR	NZ, STPO2
	SCF
	CCF
	RET
;
STPO3:	LD	A,D
	CP	A, E
	JR	NZ, STPO4
	SCF
	RET
;
;SUCHEN NL VON HINTEN BEGINNEND
;
STPO4:	LD	HL,(LETZT)
	DEC	HL
	LD	A,NL
	LD	BC,0FFFFH		;LAENGE SUCHBEREICH
	CALL	SUCHD
	INC	HL
	INC	HL
	XOR	A
	ADD	A, 1
	RET
;
;SETZEN AUF 1.ZEILE
;
SET1Z:	LD	A,1
	JR	AINCE
;
;EINE ZEILE ZURUECK
;
AZDEC:	LD	A,(AKTCZ)		;AKTUELLE CURSORZEILE
	CP	A, 1
	JR	Z, AINCE
	DEC	A
	JR	AINCE
;
;AKTUELLE BILDSCHIRMZEILE CURSOR INCREMENT.
;
AZINC:	LD	A,(AKTCZ)
	PUSH	HL
	LD	HL,MBWZZ
	CP	A, (HL)
	POP	HL
	JR	Z, AINCE
	INC	A
	JR	AINCE
;
;SETZEN AUF LETZTE ZEILE
;
SETLZ:	LD	A,(MBWZZ)
AINCE:	LD	(AKTCZ),A
	RET
;
;SETZEN AUF 1. SPALTE
;
SET1S:	LD	A,1
	JR	SETS
;
;SETZEN EINE SPALTE ZURUECK
;
BAK1S:	LD	A,(AKTCS)
	DEC	A
	RET	Z	;CURSOR AM ZEILENANF.
	JR	SETS
;
;SPALTE INCREM. Z=1 WENN LETZTE
;
ASINC:	LD	A,(AKTCS)
	PUSH	HL
	LD	HL,MBWZL
	CP	A, (HL)
	POP	HL
	RET	Z	;LETZTE BS-SPALTE ERREICHT
	INC	A
	JR	SETS		;NEACHSTE SPALTE EINST.
;
;SETZEN AUF LETZTE BS-SPALTE
;
SETLS:	LD	A,(MBWZL)
SETS:	LD	(AKTCS),A
	RET
;
;KONTROLLE AUF FREIEN RAM
;
KFREE:	LD	L,A
	PUSH	HL
	CALL	FREER
	JR	NC, KFRE1
	LD	A,1		;KEIN FREIER RAM
	LD	(FHTYP),A
KFRE1:	POP	HL
	LD	A,L
	RET
;
;ZEICHEN (A) IN TEXTPUFFER UNTERER TEIL SCHREIBEN
;
WRZIT:	CALL	KFREE		;KONTR.FREE-RAM
	RET	C
	PUSH	AF
	LD	HL,(CUPOM)
	INC	HL
	LD	(HL),A
	LD	(CUPOM),HL
	CP	A, NL
	JR	Z, WRZ1
	PUSH	HL
	LD	HL,MINS
	BIT	0,(HL)
	JR	Z, WRZ3		;INSERT-MODE
	LD	HL,(CPOM1)
	LD	A,(HL)
	CP	A, NL
	JR	Z, WRZ3
	INC	HL
	LD	(CPOM1),HL
WRZ3:	POP	HL
WRZ1:	POP	AF
	OR	A
	RET
;
;CAPS-AUSFUEHRUNG,WENN BIT 0 VON MCAPS=1
;
CAPSA:	BIT	0,(HL)
	RET	Z
WGKA:	LD	D,'~'		;WANDELRANDPUNKTE MIT UML.
	LD	E,'^'
	CP	A, 'A'
	RET	C
	CP	A, D
	RET	NC
	CP	A, 'a'
	JR	NC, WGKA1
	CP	A, E
	RET	NC
WGKA1:	XOR	20H
	RET
;
UKBM:	CALL	CLS1		;CLS MIT NEUSETZEN ZEILE
	CALL	OUTSTR
	DB	"MicroWORD 1.5",82H,"IG-HC  (c) by RB"
	DB	NL
	DB	0
	LD	B,31
UKBM1:	LD	A,'='
	CALL	STRN1
	DJNZ	UKBM1
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	"(S)start",88H,"(E)end"
	DB	NL
	DB	"(M)set mark",85H,"(N)number"
	DB	NL
	DB	"(&)all clear",84H,"(%)delete part"
	DB	NL
	DB	"(P)print file",83H,"(H)print part"
	DB	NL
	DB	"(W)write file",83H,"(V)write part"
	DB	NL
	DB	"(R)read file",84H,"(D)read part"
	DB	NL
	DB	"(X)expand",87H,"(C)compact"
	DB	NL
	DB	"(B)bye",8AH,"(A)assign"
	DB	NL
	DB	"(F)find/change",82H,"(T)write repeat"
	DB	NL
	DB	"(L)line-end",85H,"(=)NL->CRLF"
	DB	NL
	DB	88H,88H,"(-)NL->CR"
	DB	NL
	DB	"(O)out save",85H,"(I)in save"
	DB	0
;
	JR	STLN6
;
;COMPLETTE STATUSZEILE
;
STCOM:	LD	BC,(BSANF)		;BWS-ANF.
	LD	HL,(PLINE)
	ADD	HL,BC
	LD	DE,(BSSPA)
	LD	A,(MODE)
	OR	A
	JR	Z, STLN1
	SRL	E
	LD	D,0
STLN1:	SBC	HL,DE
	SBC	HL,DE
	LD	B,E
STLN5:	LD	(HL),'_'
	INC	HL
	DJNZ	STLN5
	LD	(CUPOB),HL
STLN3:	CALL	OUTSTR
	DB	"LINE POS",82H,"FREE",82H
	DB	"TXP",82H,"ETB LE M CD"
	DB	0
STLN2:	CALL	STOU1
	CALL	IMDA		;INS-MODE ANZEIGENM
	RET
;
STLN6:	CALL	STCOM
	CALL	COTAS		;TASTATURABFR.
	LD	B,A
	CALL	WGKA		;WECHSEL GROSS/KLEIN
	AND	A, B
	CALL	GOKOM
;
;KOMMANDOTABELLE
;
	DB	23		;ANZAHL KOMMANDOS
	DW	NOKOM		;KEIN KOMMANDO
	DB	"F"
	DW	FIND
	DB	"S"
	DW	CUATA
	DB	"E"
	DW	CUATE
	DB	"&"
	DW	ALLCL
	DB	"P"
	DW	PRINT
	DB	"H"
	DW	PRPRT
	DB	"M"
	DW	SETM
	DB	"%"
	DW	PARTC
	DB	"N"
	DW	NUMBR
	DB	"B"
	DW	BYE
	DB	"R"
	DW	LOAD
	DB	"W"
	DW	SAVE
	DB	"X"
	DW	EXTEN
	DB	"C"
	DW	COMPR
	DB	"A"
	DW	ASGN
	DB	"D"
	DW	RDPRT
	DB	"V"
	DW	SVPRT
	DB	"L"
	DW	SETRR
	DB	"T"
	DW	WRREP
	DB	"="
	DW	WNLCR
	DB	"-"
	DW	WNLCR1
	DB	"O"
	DW	OSAVE
	DB	"I"
	DW	ISAVE
NOKOM:	XOR	A
	RET
;
;AUSGABE STATUSZEILE
;
STOU1:	LD	DE,(ASP)
	LD	D,0
	LD	HL,(MBWSA)
	LD	BC,(PPOS)
	ADD	HL,BC
	LD	A,4
	CALL	DEZA
	LD	HL,(MBWSA)
	LD	BC,(PETX)
	ADD	HL,BC
	LD	DE,(CUPOM)
	INC	DE
	CALL	OUTDE
	CALL	FREER
	PUSH	BC
	POP	DE
	LD	HL,(MBWSA)
	LD	BC,(PFREE)
	ADD	HL,BC
	CALL	DEZA5		;5-STELLIG
	CALL	OUTLN
	CALL	TLUT
	INC	BC
	LD	DE,0
	LD	HL,(SOF)
STOU2:	EXX
	CALL	INKEY
	LD	(MZT),A
STRM:	EXX
	OR	A
	JR	NZ, STOUT
	LD	A,NL		;NL SUCHEN
	CPIR
	INC	DE
	JP	PE, STOU2
	LD	(ALINE),DE
	CALL	OUTLN
STOUT:	LD	HL,(MBWSA)
	LD	BC,(PRR)
	ADD	HL,BC
	LD	A,(RRA)		;MERKE RECHTER RAND
	LD	D,0
	LD	E,A
	LD	A,4
	CALL	DEZA
	LD	HL,(MBWSA)
	LD	BC,(PETP)
	ADD	HL,BC
	LD	DE,(TPEND)
	CALL	OUTDE
	RET
;
OUTLN:	LD	DE,(ALINE)
	LD	HL,(MBWSA)
	LD	BC,(PLINE)
	ADD	HL,BC
	LD	A,4
	CALL	DEZA
	RET
;
;FINDROUTINE
;
FIND:	CALL	LDSTP		;LADEN STRINGPUFFER
	RET	NC
ERWI:	CALL	LAEOT		;LAENGE OBERER TEIL
	JR	C, ERWI6
	INC	BC
	LD	HL,(CPOM1)
	LD	DE,TASPU
ERWI1:	LD	A,(DE)
	INC	DE
	CP	A, '/'
	JR	Z, ERWI7
	OR	A
	JR	Z, ERWI2
	CP	A, (HL)
	INC	HL
	JR	Z, ERWI1
ERWI2:	LD	HL,(CPOM1)
	INC	HL
ERWI3:	LD	DE,TASPU
	LD	A,(DE)
	CPIR
	JP	NZ, CUATE
	PUSH	HL
	PUSH	BC
ERWI4:	INC	DE
	LD	A,(DE)
	CP	A, '/'
	JR	Z, ERWI5
	OR	A
	JR	Z, ERWI5
	CPI
	JR	Z, ERWI4
	POP	BC
	POP	HL
	JR	ERWI3
;
ERWI5:	POP	BC
	POP	DE
	SBC	HL,DE
	LD	A,(MBWZZ)
	SRL	A		;GEFUNDENER STRING MITTE BS
	LD	(AKTCZ),A
	LD	A,(MBWZL)
	SUB	L
	LD	(AKTCS),A
	EX	DE,HL
	DEC	HL
	DEC	HL
	CALL	TXTNU		;TEXTT.N.UNTEN
ERWI6:	XOR	A
	RET
;
ERWI7:	LD	(CPOM1),HL
ERWI8:	LD	A,(DE)
	INC	DE
	OR	A
	JR	Z, ERWI6
	PUSH	AF
	CALL	ASINC
	POP	AF
	CALL	WRZIT
	JR	NC, ERWI8
	LD	A,1
	LD	(FHTYP),A
	JR	ERWI6
;
;CURSOR AN DEN TEXTANF.
;
CUATA:	LD	HL,(SOF)
	CALL	TXTNO		;TXT N. OBEN
	CALL	SET1Z		;1.Z.
	CALL	SET1S		;1.SP.
	XOR	A
	RET
;
;CURSOR ANS TEXTENDE
;
CUATE:	LD	HL,(LETZT)
	CALL	TXTNU		;TEXT N.UNTEN
	CALL	SETLZ		;LETZTE ZEILE
	CALL	SETLS
	XOR	A
	RET
;
ALLCL:	LD	HL,(SOF)
	DEC	HL
	LD	(CUPOM),HL
	LD	HL,(LETZT)
	INC	HL
	LD	(CPOM1),HL
	CALL	SETML		;MARKE AUF TEXTENDE
	RET
;
SETM:	LD	HL,(CUPOM)
	INC	HL
	LD	(MARK1),HL
	RET
;
PARTC:	LD	HL,(MARK1)
	CALL	TLAHL		;BC=TEXTLAENGE HL-TOPUT
	JR	NC, PART1
	LD	A,2
	LD	(FHTYP),A
	RET
;
PART1:	LD	HL,(MARK1)
	DEC	HL
	LD	(CUPOM),HL
	CALL	SETLS
	RET
;
NUMBR:	LD	HL,(MBWSA)
	LD	BC,(PINPL)
	ADD	HL,BC
	LD	(CUPOB),HL
	LD	(EPOS),HL
	CALL	INZAL
	RET	NC
	LD	A,D
	OR	E
	RET	Z
	LD	(ALINE),DE		;EING.ZEILE IN PUFFER
	PUSH	DE
	CALL	CUATA
	POP	DE
	DEC	DE
	SLA	D
	INC	D
	INC	E
	DEC	E
	JR	Z, NUMR2
NUMR1:	PUSH	DE
	CALL	STPO
	DEC	HL
	POP	DE
	JP	C, CUATE
	JP	NZ, CUATE
	PUSH	DE
	CALL	TXTNU		;TEXTT.N.UNTEN
	POP	DE
NUMR2:	DEC	D
	RET	Z
	LD	E,80H
	JR	NUMR1
;
;SPEICHERN IN DEN SAVE
;
ISAVE:	LD	HL,(CUPOM)
	INC	HL
	LD	DE,(MARK1)
	OR	A
	SBC	HL,DE
	LD	A,2		;UNDEF.
	JR	C, ISA1		;MARKE>CURSOR
	PUSH	HL		;GROESSE
	LD	DE,SAVEG		;SAVEGROESSE
	EX	DE,HL
	SBC	HL,DE
	POP	BC		;BC=LAENGE SAVEINHALT
	LD	A,1		;MEMORY ERROR
	JR	C, ISA1		;ZU GROSS
	LD	HL,(SAVEB)
	LD	DE,(TPEND)
	SBC	HL,DE
	JR	C, ISA1		;TPANF LIEGT IM SAVEBEREICH
	LD	(MLSA),BC		;SAVELAENGE MERKEN
	LD	HL,(MARK1)
	LD	DE,(SAVEB)		;SAVEBEREICH
	LDIR
	RET
ISA1:	LD	(FHTYP),A
	RET
;
;SAVE IN TEXT EINFUEGEN
;
OSAVE:	CALL	FREER
	LD	HL,(MLSA)		;FUELLMENGE SAVE
	LD	A,H
	OR	L
	RET	Z	;SAVE LEER
	PUSH	HL
	SBC	HL,BC
	LD	A,1
	POP	BC
	JR	NC, OSA1
	LD	HL,(SAVEB)
	LD	DE,(CUPOM)
	INC	DE
	LDIR
	DEC	DE
	LD	(CUPOM),DE
	RET
OSA1:	LD	(FHTYP),A
	RET
;
;TEXT HINTER UP AUSGEBEN BIS ZEI=0
;
OUTSTR:	POP	HL
	CALL	STRNG
	JP	(HL)
;
;TEXTAUSGABE AB HL BIS (HL)=0
;
STRNG:	LD	A,(HL)
	INC	HL
	OR	A
	RET	Z
	CALL	STRN1
	JR	STRNG
;
STRN1:	CP	A, NL
	JR	Z, AFNL
	BIT	7,A
	JR	NZ, SPAFL		;SPACEAUFLOESUNG
	CALL	WRZEI
	LD	A,(ANZLZ)
	DEC	A
	LD	(ANZLZ),A
	RET	NZ
	LD	A,(MBWZL)
	LD	(ANZLZ),A
	RET
;
;ZUMISCHEN VON SPACE BIS NAECHSTER
;ZEILENANFANG
;
AFNL:	LD	A,(ANZLZ)
	LD	B,A
AFNL1:	LD	A,' '
	CALL	WRZEI
	DJNZ	AFNL1
	LD	A,(MBWZL)
	LD	(ANZLZ),A
	RET
;
;CODE-SPACE-AUFLOESUNG
;ANZ=CODE-80H
;
SPAFL:	AND	A, 7FH
	LD	B,A
	LD	C,A
SPAF1:	LD	A,' '
	CALL	WRZEI
	DJNZ	SPAF1
	LD	A,(ANZLZ)
	SUB	C
	JR	Z, SPAF2
	JR	NC, SPAF3
SPAF2:	LD	C,A
	LD	A,(MBWZL)
	ADD	A, C
SPAF3:	LD	(ANZLZ),A
	RET
;
CLS1:	CALL	CLS
	LD	A,(MBWZL)
	LD	(ANZLZ),A
	RET
;
;ERMITTELN ANZAHL AUFZULOESENDER ZEICHEN (C)
;
EAAZ:	XOR	A
	CP	A, C
	JR	NZ, EAAZ1
	LD	A,(HL)
	INC	HL
	JR	EAAZ2
EAAZ1:	DEC	C
	LD	A,' '
EAAZ2:	CP	A, TAB
	JR	NZ, TRD
	LD	A,(TABRA)
	LD	C,A
	JR	EAAZ
;
;ZELLE TAB-RASTER DECREMENT
;BEI LAENGE 0 WIEDER AUF 8 SETZEN
;Z=1 WENN <A>=NL
;
TRD:	PUSH	HL
	LD	HL,TABRA
	DEC	(HL)
	JR	NZ, TRD1
	LD	(HL),8
TRD1:	POP	HL
	CP	A, NL
	RET
;
BU1:	LD	A,C
	OR	A
	JR	Z, BU3
	LD	D,C
	LD	C,0
BU2:	CALL	EAAZ		;C=ANZ.AUFZ.ZEICH.
	RET	Z	;WAR NL
	DEC	D
	JR	NZ, BU2
BU3:	CALL	EAAZ
	RET	Z	;WAR NL
	CALL	WRZEI
	DJNZ	BU3
	RET
;
BT1:	LD	A,8
	LD	(TABRA),A
	LD	A,(MBWZL)
	LD	B,A
	LD	A,(AZB1)
	LD	C,A
BT2:	CALL	BU1
	LD	A,B
	OR	A
	JR	Z, BT4
BT3:	LD	A,' '
	CALL	WRZEI
	DJNZ	BT3
BT4:	DEC	HL
	LD	BC,0FFFFH
	LD	A,NL
	CALL	SUCHI
	DEC	E
	JR	NZ, BT1
	RET
;
;
;BILDAUFBAU ENTSPRECHEND CU-POS. UND KOMMANDO
;=====================================================
;
BILD:	LD	HL,(MABN)		;AUFBLENDBEREICH NEU
	LD	(MABA),HL		; - " -          ALT
	LD	A,(AZB1)
	LD	(AZB2),A
	LD	A,(AKTCZ)
	LD	E,A		;AUFBLENDBEREICH -AKTZ ZUR.
	CALL	STXTP		;TEXTPOINTER HL SETZEN
	LD	(MABN),HL
	JR	NC, B1
	CALL	SET1Z		;1.ZEILE
	JR	B2
;
B1:	LD	A,(AKTCZ)
	SUB	E
	LD	(AKTCZ),A
B2:	LD	E,1
	CALL	STXTP
	JR	NC, B3
	CALL	SET1S		;1.SP.
	XOR	A
	LD	(AZB1),A
	JR	B6
;
B3:	LD	BC,0
	LD	A,8
	LD	(TABRA),A
B4:	CALL	EAAZ
	INC	B
	XOR	A
	CP	A, C
	JR	NZ, B4
	PUSH	HL
	PUSH	BC
	CALL	TLAHL
	POP	BC
	POP	HL
	JR	NC, B4
	LD	A,(AKTCS)
	LD	C,A
	INC	B
	LD	A,B
	SUB	C
	JR	C, B5
	LD	(AZB1),A
	JR	B6
;
B5:	LD	A,B
	LD	(AKTCS),A
	XOR	A
	LD	(AZB1),A
B6:	LD	B,A
	LD	A,(AZB2)
	CP	A, B
	JR	NZ, B7
	LD	HL,(MABN)
	LD	BC,(MABA)
	SBC	HL,BC
	JR	Z, B8
B7:	XOR	A
	LD	(EDTYP),A
B8:	LD	A,(AKTCZ)
	LD	E,A
	LD	A,(AZB3)
	SUB	E
	LD	(AZB3),A
	LD	A,(EDTYP)
	BIT	0,A
	JP	NZ, BEND
	CALL	HOME
	LD	HL,(MABN)
	DEC	E
	JR	Z, B11
	BIT	4,A
	JR	Z, B9
	BIT	3,A
	JR	NZ, B10
	LD	A,(AZB3)
	OR	A
	JR	Z, B10
	DEC	E
	CALL	NZ, CUEZU		;CURSOR E ZEILEN NACH UNTEN
	LD	E,2
	CALL	STXTP
	LD	E,1
B9:	CALL	BT1
	JR	B11
;
B10:	CALL	CUEZU		;CURSOR (E) N.UNTEN
	LD	E,1
	CALL	STXTP
B11:	LD	A,8
	LD	(TABRA),A
	LD	A,(AKTCS)
	DEC	A
	JR	Z, B12
	LD	B,A
	LD	A,(AZB1)
	LD	C,A
	CALL	BU1
B12:	LD	HL,(CUPOB)
	PUSH	HL
	LD	A,(MBWZL)
	INC	A
	LD	HL,AKTCS
	SUB	(HL)
	JR	Z, B13
	LD	B,A
	LD	C,0
	LD	E,1
	LD	HL,(CPOM1)
	CALL	BT2
	JR	B14
;
B13:	LD	E,1
	CALL	STPO
	JR	NC, B14
	LD	HL,(LETZT)
	INC	HL
B14:	EX	(SP),HL		;CU-POS. AUS STACK
	CALL	RDPOS		;CU-POS.RUECKLESEN
	PUSH	AF
	PUSH	BC
	PUSH	HL
	LD	HL,(CPOM1)
	LD	A,(HL)
	LD	HL,(PINSA)
	LD	BC,(BSANF)
	ADD	HL,BC
	INC	HL
	INC	HL
	CALL	OUTA
	POP	HL
	POP	BC
	LD	A,(CU7B)
	BIT	7,A
	JR	NZ, CUB7		;CU IST BIT 7 DES ZEICH.
	POP	AF
	CP	A, ' '
	LD	A,(MC1)
	JR	Z, KLZ
	LD	A,(MC3)
	JR	KLZ
;
;CU IST BIT 7
;
CUB7:	POP	AF
	XOR	80H		;SETZEN BIT 7
;
KLZ:	CALL	WRPOS
	LD	(HL),A
	POP	HL
	LD	A,(AKTCZ)
	LD	E,A
	LD	A,(MBWZZ)
	SUB	E
	JR	Z, BEND
	LD	E,A
	LD	A,(EDTYP)
	BIT	2,A
	JR	Z, B15
	BIT	1,A
	JR	NZ, BEND
	LD	A,(AZB3)
	OR	A
	JR	Z, BEND
	LD	E,1
B15:	CALL	BT1
BEND:	LD	A,(AKTCZ)
	LD	(AZB3),A
	RET
;
;CURSOR (E) ZEILEN NACH UNTEN
;
CUEZU:	LD	HL,(CUPOB)
	LD	A,(MBWZL)
	LD	B,0
	LD	C,A
CUEU1:	ADD	HL,BC
	DEC	E
	JR	NZ, CUEU1
	LD	(CUPOB),HL
	RET
;
;EINGABE UND FUELLEN STRINGPUFFER
;
LDSTP:	LD	A,(MCAPS)
	LD	(MCAP2),A
	LD	BC,LIPUF
	LD	HL,(MBWSA)
	LD	DE,(PINPL)
	ADD	HL,DE
	LD	(EPOS),HL
	CALL	PUEIN
	RET	NC
	LD	DE,TASPU
	OR	A
	JR	Z, LDST3
	LD	B,A
LDST1:	CALL	RDPOS
	INC	HL
	LD	(DE),A
	INC	DE
	DJNZ	LDST1
LDST3:	LD	A,0
	LD	(DE),A
	SCF
	RET
;
;DEZIMALEINGABE 3-STELLIG
;
INDE3:	LD	BC,3
IND1:	CALL	INZA3
	RET	NC
	LD	A,D
	OR	A
	JR	NZ, IND1
	LD	A,E
	SCF
	RET
;
;DEZIMALEINGABE 5-STELLIG
;
INZAL:	LD	BC,5
INZA3:	LD	HL,(CUPOB)
INZA2:	LD	(EPOS),HL
	LD	A,(ANZLZ)
	EX	AF, AF'
	CALL	PUEIN
	RET	NC
	CALL	WSTRIZ		;WANDELN STRING IN ZAHL
	JR	NC, INZA1
	EX	AF, AF'
	LD	(ANZLZ),A
	JR	INZA2
INZA1:	SCF
	RET
;
;
; STRINGEINGABE AUF BILDSCHIRM
;
PUEIN:	PUSH	BC		;B=0 C=MAX.LAENGE STR.
	PUSH	HL
;
PUEI1:	LD	A,' '		;LOESCHEN BILDBEREICH
	CALL	WRPOC
	INC	HL
	INC	B
	LD	A,B
	CP	A, C
	JR	C, PUEI1
	LD	(CUPOB),HL
	POP	HL
	POP	BC
	LD	A,(ANZLZ)
	SUB	C
	ADD	A, B
	LD	(ANZLZ),A
PUEI2:	LD	A,CUZEI
	CALL	WRPOC
PINW:	CALL	COTAS
	PUSH	HL
	CP	A, ' '
	JR	C, PUEI3
	PUSH	AF
	LD	HL,MCAP2
	CALL	CAPSA
	BIT	1,(HL)
	POP	HL
	JR	Z, PUEI3
	AND	A, H
PUEI3:	POP	HL
	CP	A, 10		;UMSCHALTEN BILDMODE
	RET	Z
	CP	A, 2		;CU-LINKS
	JR	Z, LOLZ
	CP	A, 8		;DEL-ZEICHEN LINKS
	JR	NZ, PUEI4
;
;LETZTES ZEICHEN LOESCHEN
;
LOLZ:	LD	A,B
	OR	A
	JR	Z, PINW
	LD	(HL),' '
	DEC	HL
	DEC	B
	LD	(HL),CUZEI
	PUSH	HL
	LD	HL,(EPOS)
	DEC	HL
	LD	(EPOS),HL
	POP	HL
	JR	PINW
;
;ENDE PUFFEREING.?
;
PUEI4:	CP	A, CR
	JR	NZ, PUEI6
	LD	A,B
	OR	A
PUEI5:	SCF
	RET	Z
	DEC	HL
	DEC	B
	JR	PUEI5
;
;ASCII-DRUCKZEICHEN?
;
PUEI6:	OR	A		;NUL?
	JR	Z, TABW
	CP	A, 17		;INT.TAB
	JR	NZ, KTAB
	LD	A,TAB		;RICHT.TAB
	JR	TABW
;
KTAB:	CP	A, 1BH		;ANK.STEUERZ.
	JR	NZ, KANKS
	CALL	INCHR		;STZ HOLEN
	JR	TABW
KANKS:	CP	A, ' '
	JR	C, PINW
TABW:	CALL	WRPOC
	LD	A,B
	CP	A, C
	JR	NC, PINW
	INC	HL
	INC	B
	JR	PUEI2
;
;DEZIMALAUSGABE 3 STELLIG
;
DEZA3:	LD	A,3
	JR	DEZA
;
;DEZIMALAUSG. 5 STELLIG
;
DEZA5:	LD	A,5
DEZA:	CALL	HXDEZ
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	B,A
	LD	DE,KONZ1		;KONVERTIERUNGSZELLE 1
DEZ1:	CP	A, 5
	JR	Z, DEZ2
	INC	DE
	INC	A
	JR	DEZ1
;
DEZ2:	LD	A,(DE)
	CALL	WRPOC
	INC	DE
	INC	HL
	DJNZ	DEZ2
	POP	HL
	POP	DE
	POP	BC
	RET
;
DEZ3:	CALL	HXDEZ
	LD	DE,KONZ2
	LD	B,3
DEZ4:	LD	A,(DE)
	LD	(HL),A
	INC	DE
	INC	HL
	DJNZ	DEZ4
	RET
;
;KONV. HEX-DEZ
;
HXDEZ:	PUSH	HL
	PUSH	DE
	PUSH	BC
	PUSH	AF
	LD	HL,KONZ1		;KONV.ZELLE 1
	EX	DE,HL
	CP	A, 3
	JR	Z, HXDE1
	LD	BC,2710H
	CALL	HXDE4
	LD	BC,3E8H
	CALL	HXDE4
HXDE1:	LD	BC,64H
	CALL	HXDE4
	LD	BC,0AH
	CALL	HXDE4
	LD	A,L
	CALL	HXDE6
	LD	HL,KONZ1		;KONV.ZELLE 1
	LD	B,4
HXDE2:	LD	A,(HL)
	CP	A, '0'
	JR	NZ, HXDE3
	LD	A,' '
	LD	(HL),A
	INC	HL
	DJNZ	HXDE2
HXDE3:	POP	AF
	POP	BC
	POP	DE
	POP	HL
	RET
;
HXDE4:	XOR	A
HXDE5:	INC	A
	SBC	HL,BC
	JR	NC, HXDE5
	ADD	HL,BC
	DEC	A
HXDE6:	ADD	A, 30H
	LD	(DE),A
	INC	DE
	RET
;
;WANDELN STRING IN ZAHL <DE>
;
WSTRIZ:	PUSH	HL
	PUSH	BC
	LD	DE,0
WSTRIZ1:	CALL	RDPOS
	INC	HL
	DEC	BC
	CP	A, ' '
	JR	NZ, WSTRIZ2
	LD	A,B
	OR	C
	JR	Z, WSTRIZ7
	JR	WSTRIZ1
;
WSTRIZ2:	ADD	HL,BC
	DEC	HL
	INC	BC
WSTRIZ3:	CALL	RDPOS
	DEC	HL
	DEC	BC
	CP	A, ' '
	JR	Z, WSTRIZ3
	INC	HL
	CALL	RDPOS
	OR	A
	SBC	HL,BC
	INC	BC
	LD	B,C
	LD	DE,0
	LD	C,0AH
	EX	DE,HL
	CP	A, 'D'
	JR	Z, WSTRIZ4
	CP	A, 'H'
	JR	NZ, WSTRIZ5
	LD	C,17H
WSTRIZ4:	DEC	B
	JR	Z, WSTRIZ9
WSTRIZ5:	EX	DE,HL
	CALL	RDPOS
	EX	DE,HL
	SUB	30H
	JR	C, WSTRIZ9
	CP	A, C
	JR	NC, WSTRIZ9
	PUSH	DE
	LD	D,H
	LD	E,L
	ADD	HL,HL
	JR	C, WSTRIZ8
	ADD	HL,HL
	JR	C, WSTRIZ8
	BIT	4,C
	JR	Z, WSTRIZ6
	LD	D,H
	LD	E,L
	CP	A, 0AH
	JR	C, WSTRIZ6
	CP	A, 11H
	JR	C, WSTRIZ8
	SUB	7
WSTRIZ6:	ADD	HL,DE
	JR	C, WSTRIZ8
	ADD	HL,HL
	JR	C, WSTRIZ8
	LD	D,0
	LD	E,A
	ADD	HL,DE
	POP	DE
	INC	DE
	DJNZ	WSTRIZ5
	EX	DE,HL
WSTRIZ7:	POP	BC
	POP	HL
	CP	A, A
	RET
;
WSTRIZ8:	POP	DE
WSTRIZ9:	LD	DE,0
	POP	BC
	POP	HL
	SCF
	RET
;
;WANDLUNG CRLF/CR->NL
;
WCU:	CALL	CUATA		;CURSOR AN TEXTANF.
	CALL	LAEOT		;BC=LAENGE OBERER TEXT
	LD	(MNL),A		;MERKZ. OB NL VORK.
	LD	HL,(CPOM1)
	LD	DE,(CUPOM)
	INC	DE
	RET
;
WCRNL:	CALL	WCU
	RET	C	;LEERER PUFFER
WC2:	LD	A,(HL)
	CP	A, CR
	JR	Z, WC1
	CP	A, NL
	JR	NZ, WC3
	LD	(MNL),A
WC3:	LDI
	JP	PE, WC2
WC7:	LD	A,(ETX)
	LD	(DE),A
	DEC	DE
	LD	(CUPOM),DE
	LD	(CPOM1),HL
	CALL	CUATE
	RET
;
WC1:	LD	A,(MNL)
	OR	A
	JR	Z, WC5
	INC	HL
	LD	A,(HL)
	CP	A, LF
	DEC	HL
	JR	NZ, WC3
WC5:	LD	(HL),NL
	LDI
	JP	PO, WC7
	LD	A,(HL)
	CP	A, CR
	JR	Z, WC5
	CP	A, LF
	JR	NZ, WC3
	DEC	BC
	INC	HL
	LD	A,B
	OR	C
	JR	Z, WC7
	JR	WC2
;
;WANDLUNG NL->CRLF
;
WNLCR:	CALL	WCU
	RET	C	;TB LEER
	PUSH	HL
	PUSH	BC
	EXX
	POP	BC
	POP	HL
	LD	DE,0
	LD	A,NL
WN4:	CPIR
	INC	DE
	JP	PE, WN4
	PUSH	DE		;ZEILENZAHL IN DE
	CALL	FREER
	POP	HL
	SBC	HL,BC
	EXX
	JR	C, WN1
	LD	A,1
	LD	(FHTYP),A
	RET
WN1:	LD	A,(HL)
	CP	A, NL
	JR	Z, WN2
	LDI
	JP	PE, WN1
	JR	WN5
WN2:	LD	(HL),CR
	LDI
	LD	A,LF
	LD	(DE),A
	INC	DE
	JP	PE, WN1
WN5:	DEC	DE
	LD	(CUPOM),DE
	LD	(CPOM1),HL
	JP	SAVE
;
;WANDLUNG NL->CR
;
WNLCR1:	CALL	WCU
	RET	C	;TB LEER
	PUSH	HL
	PUSH	BC
	EXX
	POP	BC
	POP	HL
	LD	DE,0
	LD	A,NL
WN14:	CPIR
	INC	DE
	JP	PE, WN14
	PUSH	DE		;ZEILENZAHL IN DE
	CALL	FREER
	POP	HL
	SBC	HL,BC
	EXX
	JR	C, WN11
	LD	A,1
	LD	(FHTYP),A
	RET
WN11:	LD	A,(HL)
	CP	A, NL
	JR	NZ, WN12
	LD	(HL),CR
WN12:	LDI
	JP	PE, WN11
	jr	WN5
;
;NEUZUWEISUNGEN
;
ASGN:	CALL	BYE1
ASGN1:	CALL	OUTSTR
	DB	NL,NL,NL
	DB	"TB-begin:"
	DB	0
	CALL	ASGNU
	JR	Z, ASGN2
	JR	NC, ASGN
	LD	HL,(ANFTX)		;MINIMALE UNTERE ADR.
	SCF
	SBC	HL,DE
	JR	NC, ASGN
	LD	(TPANF),DE
	INC	DE
	LD	(SOF),DE
ASGN2:	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	85H,"end:"
	DB	0
	CALL	ASGNU
	JR	Z, ASGN3
	JR	NC, ASGN3
	LD	HL,(SPEND)
	OR	A
	SBC	HL,DE
	JR	C, ASGN1
	LD	(TPEND),DE
ASGN3:	JP	ANF1
;
ASGNU:	CALL	LDEPS
	LD	BC,6
	CALL	INZA3
	RET	NC
	LD	A,D
	OR	E
	SCF
	RET
;
;SETZEN RECHTER RAND
;
SETRR:	LD	HL,(MBWSA)
	LD	BC,(PINPL)
	LD	DE,SRR
	ADD	HL,BC
	ADD	HL,DE
	INC	HL
	LD	(CUPOB),HL
	LD	(EPOS),HL
	LD	BC,3
	CALL	INZA3
	LD	A,E
	LD	(RRA),A
SETRE:	RET
;
;
;DRUCKERTREIBER
;==============
;
PRINT:	CALL	CUATE
	LD	HL,(SOF)
	LD	(MARK1),HL
;
PRPRT:	LD	(PUSPD),SP
	CALL	DRDEL		;RUECKS.EXT.DR.TR.
	CALL	CLS1
	LD	HL,(MARK1)
	LD	(DRPOI),HL
;
;INITIALISIERUNG DES LOGISCHEN DR. TREIBERS
;
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	"lines/page:"
	DB	0
	CALL	LDEPS		;LADEN EINGABEPOSITION
PRI1:	CALL	INDE3		;3 STELLIGE EINGABE
	RET	NC
	OR	A
	JR	Z, PRI2
	CP	A, 10		;<10=OHNE FORMAT.
	JR	C, PRI1
PRI2:	LD	(ZEIPS),A
	LD	(SZAHL),A
	OR	A
	JP	Z, PRI7
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	"with number:"
	DB	0
	CALL	LDEPS
	CALL	INDE3
	RET	NC
	LD	(SZAHL),A
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	"stop after page (Y/N)?"
	DB	0
	LD	A,2
	LD	(MFORM),A
PRI3:	LD	HL,(CUPOB)
	CALL	LDEPS		;LADEN EINGABEPOS.
PRI4:	CALL	COTAS
	CP	A, 10		;BREAK
	RET	Z
	AND	A, 0DFH		;GROSSWANDLUNG
	CP	A, 'N'
	LD	B,1
	JR	Z, PRI5
	CP	A, 'Y'
	JR	NZ, PRI4
	LD	B,0
PRI5:	CALL	STRN1
	LD	A,(MFORM)
	CP	A, 2
	JR	Z, PRI6
	OR	B
	RET	NZ
PRI6:	LD	A,B
PRI7:	LD	(MFORM),A
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	"printer is working"
	DB	0
	CALL	LDEPS
	LD	HL,(DRPOI)
PRI8:	LD	A,(ZEIPS)
	LD	(AZZPS),A
PRI9:	LD	A,8
	LD	(TABRA),A
	LD	C,0
;
;DRUCKAUSGABESCHLEIFE
;
DRZYK:	CALL	EAAZ		;C=ZAHL AUFZULOES.ZEICH.
	JR	Z, DRZY1
	CP	A, 0CH
	JR	Z, DRZY2
	CALL	OUTDR
	XOR	A
	CP	A, C
	JR	NZ, DRZYK
	CALL	KENDD		;KONTROLLE ENDE DRUCK
	JR	NC, DRZYK		;NOCH NICHT AM ENDE
	JP	ENDED		;ENDE DRUCK
;
DRZY1:	CALL	KENDD
	JP	C, ENDED
	LD	A,(AZZPS)
	CP	A, 0AH		;10 LEERZEILEN/SEITE
	JR	C, DRZY3
	DEC	A
	LD	(AZZPS),A		;AKT. ZEILENZAEHLER/SEITE
	LD	A,NL
	CALL	OUTDR
	JR	PRI9
;
DRZY2:	CALL	KENDD		;KONTROLLE ENDE DRUCK
	JP	C, ENDED
DRZY3:	CALL	ENDED
	JR	C, PRI9
	LD	A,(MFORM)
	OR	A
	JR	NZ, PRI8
	LD	(DRPOI),HL
	CALL	CLS1
	CALL	OUTSTR
	DB	NL
	DB	NL
	DB	NL
	DB	"go (Y/N)?"
	DB	0
	JP	PRI3
;
ENDED:	LD	A,(ZEIPS)
	OR	A
	JR	NZ, DRSN
ENDE1:	LD	A,NL
	CALL	OUTDR
	SCF
	RET
;
;DRUCK DER SEITENNUMMER
;
DRSN:	LD	A,(AZZPS)
	SUB	6
	LD	B,A
DRSN1:	CALL	ENDE1
	DJNZ	DRSN1
	LD	A,(SZAHL)
	OR	A
	JR	Z, DRSN4
	LD	A,(RRA)
	SUB	6		;LAENGE SEITENZ. STRING
	LD	B,1EH		;FESTER WERT
	JR	C, DRSN2
	SRL	A
	LD	B,A
DRSN2:	LD	A,' '
	CALL	OUTDR
	DJNZ	DRSN2
	PUSH	HL
	LD	HL,SZAHL
	LD	E,(HL)
	LD	D,0
	INC	(HL)
	LD	HL,PUSZ
	CALL	DEZ3
	POP	HL
	LD	DE,STRSZ
	LD	B,6		;6 ZEICHEN F. SEITENNUMMER
DRSN3:	LD	A,(DE)		;HOLEN SEITEN NUMMERNSTRING
	CALL	OUTDR
	INC	DE
	DJNZ	DRSN3
DRSN4:	LD	B,6
DRSN5:	CALL	ENDE1		;NOCH 6 NL's
	DJNZ	DRSN5
	XOR	A
	RET
;
;KONTROLLE (HL)=LETZTE ZU DRUCKENDE ZELLE?
;
KENDD:	LD	DE,(CUPOM)
	LD	A,E
	SUB	L
	LD	A,D
	SBC	A,H
	RET
;
;AUSGABE EINES ZEICHENS AUF DRUCKER
;
OUTDR:	PUSH	BC
	PUSH	DE
	PUSH	HL
	CALL	DRAKK
	CALL	INKEY
	POP	HL
	POP	DE
	POP	BC
	CP	A, 3		;BREAK?
	RET	NZ
	LD	SP,(PUSPD)
	RET
;
;LADEN EINGABEPOSITION=CURSORPOS.
;
LDEPS:	LD	HL,(EPOS)
	DEC	HL
	LD	(HL),' '		;LOESCHEN EING.CURSOR ALT
	LD	HL,(CUPOB)
	LD	(EPOS),HL		;NEUE EING.POSITION
	RET
;
;WARMSTART
;
WST:	LD	(PUFSP),SP
;;	LD	SP,STACK
	JR	GOANF
;
;EXTENDED MODE
;
EXTEN:	LD	A,(MODE)
	OR	A
	JR	NZ, GOANF
	LD	A,(BSSPA)
	SLA	A
	LD	(BSSPA),A
	LD	A,(BSZEI)
	SRL	A
	LD	(BSZEI),A
	LD	A,80H
	LD	(MODE),A
GOANF:	CALL	CUATE
	LD	HL,(TPANF)
	LD	A,(STX)
	LD	(HL),A
	LD	HL,(CUPOM)
	INC	HL
	LD	A,(ETX)
	LD	(HL),A
NEU:	JP	ANF1
;
;COMPRESS-MODE
;
COMPR:	LD	A,(MODE)
	OR	A
	JR	Z, GOANF
	LD	A,(BSSPA)
	SRL	A
	LD	(BSSPA),A
	LD	A,(BSZEI)
	SLA	A
	LD	(BSZEI),A
	XOR	A
	LD	(MODE),A
	JR	GOANF
;
;SPEZIALANPASSUNG Z9001
;======================
;

;
; Druck
;AUSGABE EINES Z.
ZDR1:	CP	A, NL
	JR	NZ, ZDR2
	LD	A,0DH		;AUFLOESUNG NL->CRLF
	CALL	ZDR2
	LD	A,0AH
ZDR2:	ld	c,a
	jp	0F00Fh		; Ausgabe eines Zeichens zu LIST


;SAVE
;<W> - write file
SAVE:	CALL	CLS
	CALL	CUATE		;CURSOR ANS TEXTENDE
	LD	HL,(TPANF)
	INC	HL
	; speichern ab (TPANF)+1
	CALL	SV1
	JR	NEU

;<V> - write part
SVPRT:	CALL	CLS
	LD	HL,(MARK1)	;TEXTMARKE
SV1:
; speichern ab HL bis CUPOM

	LD	(006Dh),HL	; AADR
	LD	HL,(CUPOM)	;CURSOR-POS.IM SPEICHER
	INC	HL
	LD	A,(ETX)
	LD	(HL),A
	LD	(006Fh),HL	; EADR

	ld	a,2		; Filename abfragen
SV2:	call	csave
	call	0FA33h		; delc
	ret
;
;WRITE WIEDERHOLEN
;<T> - write repeat
WRREP:	CALL	CLS
	LD	A,0		; FCB ist gefllt
	jr	sv2
;
;LOAD
;<R> - read file
LOAD:	CALL	CLS
	CALL	CUATE		;CURSOR ANS TEXTENDE
	LD	HL,(TPANF)
	CALL	LO1
	JR	NEU
;
;<D> - read part
RDPRT:	CALL	CLS		;CLS
	LD	HL,(CUPOM)
LO1:	INC	HL
	; laden nach HL
	ld	a,2		;Abfrage "Filename:"
	call	cload
	LD	hl,(001BH)	;DMA
	DEC	HL
	LD	(CUPOM),HL
	CALL	SETLZ
	call	0FA33h		; delc
	RET
;
;
	include	saveload.asm
;
;

;
;STRINGPUFFER DRUCK SEITENZAHL
;
STRSZ:	DB	"-"		;STRING SEITNZAHL
PUSZ:	DB	"    -"		;PUFFER SEITENZAHL
;
;ARBEITSZELLEN
;
MODE:	DB	0		;MERKE MODE
EPOS:	DB	2	 dup (?)	;MERKE EINGABE-POSITION
MBWSA:	DB	2	 dup (?)	;MERKE BWS-ANFANG
CUPOB:	DB	2	 dup (?)	;CURSOR-POS. BILDSCHIRM
SOF:	DB	2	 dup (?)	;POSITION 1.TEXTZEICHEN
CUPOM:	DB	2	 dup (?)	;CU-POSITION IM SPEICHER
CPOM1:	DB	2	 dup (?)	;POSIT.ZEICHEN NACH CU IM SPEICHER
LETZT:	DB	2	 dup (?)	;POS.LETZT.ZEI.+1 IM OBEREN TEIL
MBWZL:	DB	1	 dup (?)	;MERKE BWS SPALTENZAHL
MBWZZ:	DB	1	 dup (?)	;MERKE BWS ZEILENZAHL
PLINE:	DB	2	 dup (?)	;MERKE POSITION BWS LINE
PINPL:	DB	2	 dup (?)	;MERKE POS. INPUT-LINE
PRR:	DB	2	 dup (?)	;MERKE POS. RECHTER RAND
PFREE:	DB	2	 dup (?)	;MERKE POS. BWS FREE
PINSA:	DB	2	 dup (?)	;MERKE POS. INS-ANZEIGE
PUFSP:	DB	2	 dup (?)	;PUFFER STACKPOINTER
AKTCS:	DB	1	 dup (?)	;AKTUELLE CURSOR-POS. SPALTE
AKTCZ:	DB	1	 dup (?)	;AKT. CU-POS. ZEILE
MARK1:	DB	2	 dup (?)	;TEXTMARKE
FHTYP:	DB	1	 dup (?)	;FEHLERTYP 0=KEIN FEHLER
MCAPS:	DB	2EH		;MERKE CAPS BIT0
MABN:	DB	2	 dup (?)	;MERKE BEGINN AUFBLENDBER.NEU
MABA:	DB	2	 dup (?)	;MERKE AUFBL.-BER. ALT
AZB1:	DB	1	 dup (?)	;ARBEITSZELLEN BILDSCHIRMTREIBER
AZB2:	DB	1	 dup (?)	;
AZB3:	DB	1	 dup (?)	;
EDTYP:	DB	1	 dup (?)	;MERKE EDITIER-KOMMANDO
TABRA:	DB	1	 dup (?)	;MERKE TAB-RASTER
ANZLZ:	DB	1	 dup (?)	;ANZAHL LEERZEICHEN
KONZ1:	DB	2	 dup (?)	;KONVERTIERUNGSZELLEN 1 HEXA
KONZ2:	DB	3	 dup (?)	;KONVERTIERUNGSZELLEN 2 BCD
MCAP2:	DB	0		;MERKE CAPS EINGABEPUFFER
DRPOI:	DB	2	 dup (?)	;DRUCK.POINTER
PUSPD:	DB	2	 dup (?)	;PUFFER STACKPOINTER DRUCK
MFORM:	DB	1	 dup (?)	;MERKE DRUCKMODE
ZEIPS:	DB	1	 dup (?)	;ZEILEN PRO SEITE
AZZPS:	DB	1	 dup (?)	;AKTUELLER ZEILENZAEHLER/SEITE
SZAHL:	DB	1	 dup (?)	;SEITENZAHL
PETX:	DB	2	 dup (?)	;POS. TEXTPUFFERPOINTER
PETP:	DB	2	 dup (?)	;POS. ENDE TEXTPUFFER
PPOS:	DB	2	 dup (?)	;POS. SPALTE
SPEND:	DB	2	 dup (?)	;PHYS. SPEICHERENDE
ALINE:	DW	1		;MERKE AKTUELLE ZEILE
ASP:	DB	0		;MERKE AKTUELLE SPALTE
RRA:	DB	65		;MERKE RECHTER RAND
MNL:	DB	1	 dup (?)	;MERKE VORK. NL
MINS:	DB	0		;MERKE INSERT-MODE
MLSA:	DW	0		;MERKE LAENGE TEXT IM SAVE
MZT:	DB	0		;MERKE ZEICHEN VON TASTATUR
TASPU:	DB	LIPUF	 dup (?)	;TASTATURPUFFER FUER FIND
;
;

firstp	equ	$ & 0FF00H+0FFh

	END

